Subject: Re: [Patch iproute2] vxlan: use 8472 as default dst port

From: Stephen Hemminger <[email-masked]>
Date: Wed, 15 May 2013 10:43:08 -0700

On Wed, 15 May 2013 13:19:43 -0400
David Stevens <[email-masked]> wrote:

> [email-masked] wrote on 05/15/2013 12:53:22 PM:
> 
> > From: Stephen Hemminger <[email-masked]>
>  
> > No. I want all users to get the IANA assigned port unless they 
> specifically
> > override it. For compatibility kernel can't change to the IANA value
> > but user space needs to nudge users in the correct direction.
> 
> It's more than a nudge -- it doesn't interoperate with itself.
> 
> 1) The kernel binds to 8472 on module load.
> 2) After it's bound, iproute2 "changes" the port to 4789, but
>         the kernel binding is still 8742 for listening. All destinations 
> use
>         the new port, but all bindings use the old port.
> 
> So, boot two systems without specifying a port and they can't
> talk to each other. They both listen on 8742 and they both send to
> 4789.
> 
> This clearly is worse than changing the kernel default port to 4789, but
> what's the point of having a kernel default if a user-level program 
> overrides
> it even when the user did not specify a port, and only for half of it (the
> sender side)?
> 
> You could make a port change close and rebind, but that's little different
> than changing the default in the kernel, if "ip" does it without a port
> specification. 
>                                                                 +-DLS
> 

I want all new users to get the IANA port without asking.
Old users with existing nets have to force the port to the one they were using.